import 'package:sqflite/sqflite.dart';
import 'package:path/path.dart';
import 'dart:convert';
import 'package:crypto/crypto.dart';

class User {
  String name;
  String password;
  String email;
  String tiendaId;

  User.fromMap(Map<String, dynamic> map)
      : name = map['name'],
        password = map['password'],
        email = map['email'],
        tiendaId = map['tiendaId'];

  Map<String,dynamic> toMap(){
    return {name:this.name,password:this.password,tiendaId:this.tiendaId};
  }

}

class POS_sqlite {
  Database _db;
  String dbName;
  User usuario;

  POS_sqlite(this.dbName);

  Future<bool> abrirConexion(String name, String password) async {
    try {

      this._db = await openDatabase(
        join(await getDatabasesPath(), this.dbName),
        onCreate: (db, ver) {
          db.execute(
              """
CREATE TABLE User (name varchar(100), password varchar(100), email varchar(50), tiendaId varchar(6), UNIQUE (name,tiendaId))"""
          );
        },
        version: 1,
      );
      this.usuario = await buscarUsuario(name, password);
      return ((this.usuario) != null) ? true : false;
    } on Exception catch(e){
      return Future.error(
          "Hubo problemas al abrir o crear la base de datos local: "+e.toString());
    }
  }

  Future<User> buscarUsuario(String name, String password) async {
    List<Map<String, dynamic>> founds = await this._db.query(
        "User",
        where: "name = ? and password = ?",
        whereArgs: [name, generadarMd5(password)],
        limit: 1
    );
    if (founds.length > 0) {
      return User.fromMap(founds.first);
    } else {
      return new Future.error("No existe usuario");
    }
  }

  Future<int> registrar_usuario(User nuevoUsuario) {
    if (this._db != null) {
      return this._db.insert("User", nuevoUsuario.toMap());
    }else{
      return Future.error("No esta conectado a nunguna base de datos");
    }
  }

  String generadarMd5(String input) {
    return md5.convert(utf8.encode(input)).toString();
  }
}
